
;--------------------------------------------------------;
; File risorse.asm                                       ;
; Risorse Icon, Cursor, Bitmap e Dialog in Win32         ;
;--------------------------------------------------------;

; ################# direttive per l'assembler #################

.386                                   ; set di istruzioni a 32 bit
.MODEL      FLAT, STDCALL              ; memory model & calling conventions
OPTION      CASEMAP: NONE              ; case sensitive on symbols

; ############### dichiarazione tipi e costanti ###############

; ########################## macro ############################

; trasferimento dati da mem32 a mem32

MOV32 MACRO Destinazione, Sorgente

   push     Sorgente
   pop      Destinazione

ENDM

; crea un dato di tipo COLORREF

MAKE_COLORREF MACRO intRed, intGreen, intBlue

   xor      eax, eax                   ; eax = 0
   mov      ah, intBlue
   shl      eax, 8                     ; eax = 00h, Blue, 00h, 00h
   mov      ah, intGreen               ; eax = 00h, Blue, Green, 00h
   mov      al, intRed                 ; eax = 00h, Blue, Green, Red

ENDM

; #################### inclusione librerie ####################

INCLUDE     ..\..\include\windows.inc  ; header file principale di Win32
INCLUDE     ..\..\include\user32.inc   ; interfaccia per USER32.LIB
INCLUDE     ..\..\include\kernel32.inc ; interfaccia per KERNEL32.LIB
INCLUDE     ..\..\include\gdi32.inc    ; interfaccia per GDI32.LIB
INCLUDE     risorse.inc                ; header  file per Risorse.asm

INCLUDELIB  ..\..\lib\user32.lib       ; libreria interfaccia utente
INCLUDELIB  ..\..\lib\kernel32.lib     ; libreria di sistema
INCLUDELIB  ..\..\lib\gdi32.lib        ; libreria grafica

; ################ segmento dati inizializzati #################

_DATA       SEGMENT  DWORD PUBLIC USE32 'DATA'

className      db       'Risorse', 0
winTitle       db       'Win32 Assembly - Applicazione Risorse', 0
menuName       db       'RisorseMenu', 0
iconName       db       'RisorseIcon', 0

bitmap1Name    db       'RisorseBmp1', 0
bitmap2Name    db       'RisorseBmp2', 0
bitmap3Name    db       'RisorseBmp3', 0
bitmap4Name    db       'RisorseBmp4', 0

cursor1Name    db       'RisorseCursor1', 0
cursor2Name    db       'RisorseCursor2', 0
cursor3File    db       'libro.cur', 0
cursor4File    db       'penna.cur', 0
animcurFile    db       'dinosau2.ani', 0

AboutDlgName   db       'RisorseAboutDlg', 0

font1Name      db       'Times New Roman', 0
font2Name      db       'Arial', 0
font3Name      db       'Georgia', 0
font4Name      db       'Verdana', 0
font5Name      db       'Symbol', 0
font6Name      db       'Tahoma', 0
font7Name      db       'Trebuchet MS', 0
font8Name      db       'Courier New', 0
font9Name      db       'Comic Sans MS', 0

msgTitolo      db       'Win 32 Assembly', 0

msgClose       db       'Procedura Risorse_OnClose.', 10       
               db       'Messaggio WM_CLOSE ricevuto!', 10
               db       'Chiudere RISORSE.EXE ?', 0

msgError       db       'Help non disponibile!', 0

strFormat      db       'Codice Menu Item = %u', 0
strBuffer      db       128 dup (0)

strFont        db       'Font Selezionato', 0

   ALIGN       4                          ; allineamento dati alla DWORD

handleFont     dd       0                 ; handle Font corrente

_DATA       ENDS

; ############## segmento dati non inizializzati ##############

_BSS        SEGMENT  DWORD PUBLIC USE32 'BSS'

hInstance      dd       ?                 ; handle dell'applicazione
commandLine    dd       ?                 ; puntatore alla command line
hWindow        dd       ?                 ; handle della main window

handleBitmap1  dd       ?                 ; handle Bitmap1
handleBitmap2  dd       ?                 ; handle Bitmap2
handleBitmap3  dd       ?                 ; handle Bitmap3
handleBitmap4  dd       ?                 ; handle Bitmap4

handleCursor1  dd       ?                 ; handle Cursor1
handleCursor2  dd       ?                 ; handle Cursor2
handleCursor3  dd       ?                 ; handle Cursor3
handleCursor4  dd       ?                 ; handle Cursor4
handleCursor5  dd       ?                 ; handle Cursor5

fontStruct     LOGFONT  <?>               ; struttura LOGFONT

_BSS        ENDS

; ##################### segmento di codice #####################

_TEXT       SEGMENT DWORD PUBLIC USE32 'CODE'

start:                                 ; entry point del programma

; ----------------- blocco inizializzazioni --------------------

   invoke   GetModuleHandle, NULL      ; trova l'handle del modulo FONTWIN.EXE
   mov      hInstance, eax             ; e lo salva in hInstance

   invoke   GetCommandLine             ; trova l'indirizzo della command line
   mov      commandLine, eax           ; e lo salva in commandLine

; ------------ blocco definizione della main window ------------

   invoke   WinMain, hInstance, NULL, commandLine, SW_SHOWNORMAL

; ---------------- blocco deinizializzazioni -------------------

   invoke   ExitProcess, eax           ; exit code restituito da WinMain

; ---------------- inizio blocco procedure ---------------------

;----------------------------------------------------------------------------------;
; int WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow) ;
;----------------------------------------------------------------------------------;
; Procedura principale dell'applicazione. All'interno di WinMain si svolgono le    ;
; fasi di inizializzazione, registrazione, attivazione e gestione della Main Window;
;----------------------------------------------------------------------------------;

WinMain proc hInst :DWORD, hPrevInst :DWORD, lpCmdLine :DWORD, nCmdShow :DWORD

   LOCAL    wc       :WNDCLASSEX       ; crea wc nello stack
   LOCAL    msg      :MSG              ; crea msg nello stack

; inizializzazione main window

   invoke   MemSet, addr wc, 0, SIZEOF WNDCLASSEX  ; inizializza wc con zeri

   mov      wc.cbSize, SIZEOF WNDCLASSEX           ; dimensioni struttura
   mov      wc.style, CS_HREDRAW OR CS_VREDRAW     ; stile della win. class
   mov      wc.lpfnWndProc, offset WndProc         ; indirizzo window procedure
   mov      wc.cbClsExtra, 0                       ; byte extra per la win. class
   mov      wc.cbWndExtra, 0                       ; byte extra per la win. instance
   MOV32    wc.hInstance, hInstance                ; handle dell'applicazione
   invoke   LoadIcon, hInstance, offset iconName   ; eax = handle icona
   mov      wc.hIcon, eax                          ; icona dell'applicazione
   invoke   LoadCursor, NULL, IDC_ARROW            ; eax = handle cursore
   mov      wc.hCursor, eax                        ; cursore dell'applicazione
   MAKE_COLORREF 0, 100, 0                         ; crea una terna RGB
   invoke   CreateSolidBrush, eax                  ; e la converte in HBRUSH
   mov      wc.hbrBackground, eax                  ; colore di sfondo della finestra
   mov      wc.lpszMenuName, offset menuName       ; nome della risorsa menu
   mov      wc.lpszClassName, offset className     ; nome della classe finestra
   mov      wc.hIconSm, NULL                       ; icona piccola dell'applicazione

; registrazione main window

   invoke   RegisterClassEx, addr wc               ; richiesta di registrazione
   test     eax, eax                               ; errore ?
   jz       exitWinMain                            ; termina con eax = 0

; attivazione della main window

   invoke   CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, offset className,
                            offset winTitle, WS_OVERLAPPEDWINDOW,
                            CW_USEDEFAULT, CW_USEDEFAULT,
                            CW_USEDEFAULT, CW_USEDEFAULT,
                            NULL, NULL, hInstance, NULL

   test     eax, eax                               ; errore ?
   jz       exitWinMain                            ; termina con eax = 0
   mov      hWindow, eax                           ; salva l'HWND della finestra in hWindow
   invoke   ShowWindow, hWindow, nCmdShow          ; visualizza la finestra
   invoke   UpdateWindow, hWindow                  ; aggiorna l'area client
   test     eax, eax                               ; errore ?
   jz       exitWinMain                            ; termina con eax = 0

; gestione della main window

MessageLoop:
   invoke   GetMessage, addr msg, NULL, 0, 0       ; estrazione prossimo messaggio
   test     eax, eax                               ; eax = 0 ?
   jz       exitMessageLoop                        ; fine del loop (WM_QUIT)
   invoke   TranslateMessage, addr msg             ; decodifica messaggio
   invoke   DispatchMessage, addr msg              ; invio messaggio alla WinProc
   jmp      MessageLoop                            ; ripeti
exitMessageLoop:

   mov      eax, msg.wParam                        ; exit code = OK

exitWinMain:                                       ; exit code = 0 (errore)

   ret

WinMain endp

;----------------------------------------------------------------------------------;
; LRESULT WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)              ;
;----------------------------------------------------------------------------------;
; Window procedure della Main Window dell'applicazione. WndProc viene utilizzata   ;
; dal SO per inviare i messaggi alla Main Window.                                  ;
;----------------------------------------------------------------------------------;

WndProc proc hWnd :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD

messaggio_WM_CREATE:
   cmp      uMsg, WM_CREATE            ; (uMsg == WM_CREATE) ?
   jne      messaggio_WM_PAINT
   invoke   Risorse_OnCreate, hWnd, lParam
   jmp      messaggio_restituito       ; passa WM_CREATE a DefWindowProc
messaggio_WM_PAINT:
   cmp      uMsg, WM_PAINT             ; (uMsg == WM_PAINT) ?
   jne      messaggio_WM_COMMAND
   invoke   Risorse_OnPaint, hWnd
   jmp      exitWndProc
messaggio_WM_COMMAND:
   cmp      uMsg, WM_COMMAND           ; (uMsg == WM_COMMAND) ?
   jne      messaggio_WM_CLOSE
   mov      eax, wParam                ; eax = wParam
   mov      ecx, eax                   ; ecx = wParam
   and      eax, 0000ffffh             ; eax = id = LOWORD(wParam)
   shr      ecx, 16                    ; ecx = codeNotify = HIWORD(wParam)
   invoke   Risorse_OnCommand, hWnd, eax, lParam, ecx
   jmp      exitWndProc
messaggio_WM_CLOSE:
   cmp      uMsg, WM_CLOSE             ; (uMsg == WM_CLOSE) ?
   jne      messaggio_WM_DESTROY
   invoke   Risorse_OnClose, hWnd
   cmp      eax, IDYES                 ; conferma chiusura programma ?
   jne      exitWndProc
   jmp      messaggio_restituito       ; passa WM_CLOSE a DefWindowProc
messaggio_WM_DESTROY:
   cmp      uMsg, WM_DESTROY           ; (uMsg == WM_DESTROY) ?
   jne      messaggio_restituito
   invoke   Risorse_OnDestroy, hWnd
   jmp      exitWndProc
messaggio_restituito:
   invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
   ret
exitWndProc:

   xor      eax, eax
   ret

WndProc endp

; ------------- procedure usate da WndProc ------------

;-------------------------------------------------------------;
; BOOL Cls_OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct) ;
;-------------------------------------------------------------;
; risposta al messaggio WM_CREATE                             ;
;-------------------------------------------------------------;

Risorse_OnCreate proc hwnd :DWORD, lpCreateStruct :DWORD

   ; caricamento bitmap

   invoke   LoadBitmap, hInstance, offset bitmap1Name
   mov      handleBitmap1, eax
   invoke   LoadBitmap, hInstance, offset bitmap2Name
   mov      handleBitmap2, eax
   invoke   LoadBitmap, hInstance, offset bitmap3Name
   mov      handleBitmap3, eax
   invoke   LoadBitmap, hInstance, offset bitmap4Name
   mov      handleBitmap4, eax

; caricamento cursori

   invoke   LoadCursor, hInstance, offset cursor1Name
   mov      handleCursor1, eax
   invoke   LoadCursor, hInstance, offset cursor2Name
   mov      handleCursor2, eax
   invoke   LoadCursorFromFile, offset cursor3File
   mov      handleCursor3, eax
   invoke   LoadCursorFromFile, offset cursor4File
   mov      handleCursor4, eax
   invoke   LoadCursorFromFile, offset animcurFile
   mov      handleCursor5, eax

; inizializzazione struttura LOGFONT

   invoke   MemSet, offset fontStruct, 0, SIZEOF LOGFONT

   mov      fontStruct.lfHeight, 80
   mov      fontStruct.lfWeight, 700
   mov      fontStruct.lfEscapement, 0
   mov      fontStruct.lfItalic, FALSE
   mov      fontStruct.lfUnderline, FALSE
   mov      fontStruct.lfCharSet, ANSI_CHARSET
   mov      fontStruct.lfOutPrecision, OUT_TT_ONLY_PRECIS
   mov      fontStruct.lfClipPrecision, CLIP_DEFAULT_PRECIS
   mov      fontStruct.lfQuality, DEFAULT_QUALITY
   mov      fontStruct.lfPitchAndFamily, VARIABLE_PITCH OR FF_ROMAN
   
   mov      eax, TRUE
   ret

Risorse_OnCreate endp

;-----------------------------------------------------;
; void Cls_OnPaint(HWND hwnd);                        ;
;-----------------------------------------------------;
; risposta al messaggio WM_PAINT                      ;
;-----------------------------------------------------;

Risorse_OnPaint proc hwnd :DWORD

   LOCAL    paintStruct :PAINTSTRUCT   ; struttura PAINTSTRUCT
   LOCAL    paintRect   :RECT          ; area di output
   LOCAL    paintDC     :HDC           ; handle to DC
   LOCAL    hOldFont    :HFONT         ; handle vecchio font

   invoke   BeginPaint, hwnd, addr paintStruct  ; richiede un DC      
   mov      paintDC, eax                        ; e lo salva in paintDC

   cmp      handleFont, 0              ; if (handleFont == 0)
   je       exit_paint

   invoke   GetClientRect, hwnd, addr paintRect ; rettangolo client area
   
   invoke   SetBkMode, paintDC, TRANSPARENT
   MAKE_COLORREF 230, 230, 0
   invoke   SetTextColor, paintDC, eax
   invoke   SelectObject, paintDC, handleFont
   mov      hOldFont, eax
   invoke   DrawText, paintDC, offset strFont, -1, addr paintRect, (DT_SINGLELINE OR DT_CENTER OR DT_VCENTER)
   invoke   SelectObject, paintDC, hOldFont

exit_paint:

   invoke   EndPaint, hwnd, addr paintStruct

   ret

Risorse_OnPaint endp

;--------------------------------------------------------------------------;
; void Cls_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)     ;
;--------------------------------------------------------------------------;
; risposta al messaggio WM_COMMAND                                         ;
;--------------------------------------------------------------------------;

Risorse_OnCommand proc hwnd :DWORD, id :DWORD, hwndCtl :DWORD, codeNotify :DWORD

   mov      eax, id                       ; eax = codice comando

;----------- popup "Principale" -------------

   cmp      eax, CM_MENU1a                ; if (id >= CM_MENU1a)
   jb       exit_command
   cmp      eax, CM_MENU1c                ; AND (id <= CM_MENU1c)
   ja       test_menuexit
   invoke   wsprintf, offset strBuffer, offset strFormat, eax
   invoke   MessageBox, hwnd, offset strBuffer, offset msgTitolo, MB_OK OR MB_ICONINFORMATION
   jmp      exit_command
test_menuexit:
   cmp      eax, CM_MENUEXIT              ; if (id == CM_MENUEXIT)
   jne      test_popup_bitmap
   invoke   SendMessage, hwnd, WM_CLOSE, NULL, NULL
   jmp      exit_command

;------------ popup "Bitmap" -------------

test_popup_bitmap:
   cmp      eax, CM_BITMAP1               ; if (id >= CM_BITMAP1)
   jne      test_menu_bitmap2
   invoke   CreatePatternBrush, handleBitmap1
   invoke   SetClassLong, hwnd, GCL_HBRBACKGROUND, eax
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_bitmap2:
   cmp      eax, CM_BITMAP2               ; if (id >= CM_BITMAP2)
   jne      test_menu_bitmap3
   invoke   CreatePatternBrush, handleBitmap2
   invoke   SetClassLong, hwnd, GCL_HBRBACKGROUND, eax
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_bitmap3:
   cmp      eax, CM_BITMAP3               ; if (id >= CM_BITMAP3)
   jne      test_menu_bitmap4
   invoke   CreatePatternBrush, handleBitmap3
   invoke   SetClassLong, hwnd, GCL_HBRBACKGROUND, eax
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_bitmap4:
   cmp      eax, CM_BITMAP4               ; if (id >= CM_BITMAP4)
   jne      test_menu_bitmap5
   invoke   CreatePatternBrush, handleBitmap4
   invoke   SetClassLong, hwnd, GCL_HBRBACKGROUND, eax
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_bitmap5:
   cmp      eax, CM_BITMAP5               ; if (id >= CM_BITMAP5)
   jne      test_popup_cursori
   MAKE_COLORREF 0, 100, 0
   invoke   CreateSolidBrush, eax
   invoke   SetClassLong, hwnd, GCL_HBRBACKGROUND, eax
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command

;----------- popup "Cursori" -------------

test_popup_cursori:
   cmp      eax, CM_CURSOR1               ; if (id >= CM_CURSOR1)
   jne      test_menu_cursor2
   invoke   SetClassLong, hwnd, GCL_HCURSOR, handleCursor1
   jmp      exit_command
test_menu_cursor2:
   cmp      eax, CM_CURSOR2               ; if (id >= CM_CURSOR2)
   jne      test_menu_cursor3
   invoke   SetClassLong, hwnd, GCL_HCURSOR, handleCursor2
   jmp      exit_command
test_menu_cursor3:
   cmp      eax, CM_CURSOR3               ; if (id >= CM_CURSOR3)
   jne      test_menu_cursor4
   invoke   SetClassLong, hwnd, GCL_HCURSOR, handleCursor3
   jmp      exit_command
test_menu_cursor4:
   cmp      eax, CM_CURSOR4               ; if (id >= CM_CURSOR4)
   jne      test_menu_cursor5
   invoke   SetClassLong, hwnd, GCL_HCURSOR, handleCursor4
   jmp      exit_command
test_menu_cursor5:
   cmp      eax, CM_CURSOR5               ; if (id >= CM_CURSOR5)
   jne      test_menu_cursor6
   invoke   SetClassLong, hwnd, GCL_HCURSOR, handleCursor5
   jmp      exit_command
test_menu_cursor6:
   cmp      eax, CM_CURSOR6               ; if (id >= CM_CURSOR6)
   jne      test_popup_font
   invoke   LoadCursor, NULL, IDC_ARROW   ; cursore predefinito
   invoke   SetClassLong, hwnd, GCL_HCURSOR, eax
   jmp      exit_command

;------------- popup "Font" --------------

test_popup_font:
   cmp      eax, CM_FONT1                 ; if (id == CM_FONT1)
   jne      test_menu_font2
   invoke   SetFont, offset font1Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_font2:
   cmp      eax, CM_FONT2                 ; if (id == CM_FONT2)
   jne      test_menu_font3
   invoke   SetFont, offset font2Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_font3:
   cmp      eax, CM_FONT3                 ; if (id == CM_FONT3)
   jne      test_menu_font4
   invoke   SetFont, offset font3Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_font4:
   cmp      eax, CM_FONT4                 ; if (id == CM_FONT4)
   jne      test_menu_font5
   invoke   SetFont, offset font4Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_font5:
   cmp      eax, CM_FONT5                 ; if (id == CM_FONT5)
   jne      test_menu_font6
   invoke   SetFont, offset font5Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_font6:
   cmp      eax, CM_FONT6                 ; if (id == CM_FONT6)
   jne      test_menu_font7
   invoke   SetFont, offset font6Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_font7:
   cmp      eax, CM_FONT7                 ; if (id == CM_FONT7)
   jne      test_menu_font8
   invoke   SetFont, offset font7Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_font8:
   cmp      eax, CM_FONT8                 ; if (id == CM_FONT8)
   jne      test_menu_font9
   invoke   SetFont, offset font8Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command
test_menu_font9:
   cmp      eax, CM_FONT9                 ; if (id == CM_FONT9)
   jne      test_popup_informazioni
   invoke   SetFont, offset font9Name
   invoke   InvalidateRect, hwnd, NULL, TRUE
   jmp      exit_command

;----------- popup "Informazioni" -------------

test_popup_informazioni:
   cmp      eax, CM_HELP                  ; if (id == CM_HELP)
   jne      test_menu_about
   invoke   MessageBox, hwnd, offset msgError, offset msgTitolo, MB_OK OR MB_ICONWARNING
   jmp      exit_command
test_menu_about:
   cmp      eax, CM_ABOUT                 ; if (id == CM_ABOUT)
   jne      exit_command
   invoke   DialogBoxParam, hInstance, offset AboutDlgName, hwnd, offset AboutWinProc, NULL

exit_command:

   ret

Risorse_OnCommand endp

;------------------------------------------------------;
; void Cls_OnClose(HWND hwnd);                         ;
;------------------------------------------------------;
; risposta al messaggio WM_CLOSE                       ;
;------------------------------------------------------;

Risorse_OnClose proc hwnd :DWORD

   invoke   MessageBox, hwnd, offset msgClose, offset msgTitolo, MB_YESNO OR MB_ICONQUESTION

   ret               ; eax = return value (IDYES o IDNO)
    
Risorse_OnClose endp

;------------------------------------------------------;
; void Cls_OnDestroy(HWND hwnd);                       ;
;------------------------------------------------------;
; risposta al messaggio WM_DESTROY                     ;
;------------------------------------------------------;

Risorse_OnDestroy proc hwnd :DWORD

   ; distruzione risorse bitmap

   invoke   DeleteObject, handleBitmap1
   invoke   DeleteObject, handleBitmap2
   invoke   DeleteObject, handleBitmap3
   invoke   DeleteObject, handleBitmap4

; distruzione risorsa font

   cmp      handleFont, 0                 ; pulizia risorse Font
   je       short exit_destroy
   invoke   DeleteObject, handleFont
exit_destroy:

   invoke   PostQuitMessage, NULL         ; messaggio di terminazione

   ret

Risorse_OnDestroy endp

;**********************************************;
;      gestione DialogBox RisorseAboutDlg      ;
;**********************************************;

;--------------------------------------------------------------------------------;
; BOOL CALLBACK AboutWinProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) ;
;--------------------------------------------------------------------------------;
; window procedure della finestra di about                                       ;
;--------------------------------------------------------------------------------;

AboutWinProc proc hDlg :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD

   LOCAL    retVal :DWORD                 ; return value

   mov      eax, uMsg                     ; eax = messaggio
aboutmsg_WM_INITDIALOG:
   cmp      eax, WM_INITDIALOG            ; uMsg == WM_INITDIALOG ?
   jne      aboutmsg_WM_COMMAND
   mov      retVal, TRUE                  ; return value = TRUE
   jmp      exit_aboutwinproc
aboutmsg_WM_COMMAND:
   mov      retVal, FALSE                 ; return value = FALSE
   cmp      eax, WM_COMMAND               ; uMsg == WM_COMMAND ?
   jne      exit_aboutwinproc
   mov      eax, wParam
   and      eax, 0000ffffh                ; ID = LOWORD(wParam)
aboutmsg_ID:
   cmp      eax, IDOK                     ; ID == pulsante OK premuto ?
   je       msgabout_continue
   cmp      eax, IDCANCEL                 ; ID == richiesta di chiusura ?
   je       msgabout_continue
   jmp      exit_aboutwinproc
msgabout_continue:
   mov      retVal, TRUE
   invoke   EndDialog, hDlg, retVal       ; chiude la DialogBox
exit_aboutwinproc:
   mov      eax, retVal                   ; eax = return value
   
   ret

AboutWinProc endp

;**********************************************;
;         libreria di procedure varie          ;
;**********************************************;

; void SetFont(DWORD ptFontName)
; seleziona il nome del Font

SetFont proc ptFontName :DWORD

   invoke   StrCpy, offset fontStruct.lfFaceName, ptFontName

   cmp      handleFont, 0
   je       short exit_setfont
   invoke   DeleteObject, handleFont
exit_setfont:
   invoke   CreateFontIndirect, offset fontStruct
   mov      handleFont, eax

   ret

SetFont endp

; void MemSet(DWORD *ptrMem, DWORD fillValue, DWORD fillSize)
; riempie con fillSize byte un blocco di memoria puntato da ptrMem

MemSet proc ptrMem :DWORD, fillValue :DWORD, fillSize :DWORD

   push     edi                        ; salva il contenuto di edi

   mov      edi, ptrMem                ; edi punta al blocco di memoria da inizializzare
   mov      eax, fillValue             ; al = byte ptr fillValue[0] (inizializzatore)
   mov      ecx, fillSize              ; ecx = n. byte da riempire (contatore)
   cld                                 ; DF = 0 (incremento automatico puntatori)
   rep      stosb                      ; riempie [ptrMem] con fillValue byte
   
   pop      edi                        ; ripristina il vecchio contenuto di edi
   ret

MemSet endp

; void StrCpy(CHAR *strTo, CHAR *strFrom);
; copia la stringa C strFrom in strTo

StrCpy proc strTo :DWORD, strFrom :DWORD

   mov      ecx, strFrom               ; ecx punta a strFrom
   mov      edx, strTo                 ; edx punta a strto
strcpy_loop:
   mov      al, [ecx]                  ; copia un byte da
   mov      [edx], al                  ; [ecx] a [edx]
   inc      ecx                        ; prossimo byte sorgente
   inc      edx                        ; prossimo byte destinaz.
   test     al, al                     ; fine stringa ?
   jnz      strcpy_loop

   ret

StrCpy endp

;**********************************************;
;                 fine libreria                ;
;**********************************************;

; -------------------- fine blocco procedure -------------------

_TEXT       ENDS

; ##############################################################

   END      start                   ; fine del modulo
